/*
 * Created on 2004/07/01
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.io;

import java.io.IOException;
import java.io.InputStream;

/**
 * 
 *
 */
public class LineSeparatorCountInputStream extends InputStream{
private InputStream input;
private int r;
private int n;
private int rn;

    /* (non-Javadoc)
     * @see java.io.InputStream#read()
     */
protected String datas;
public LineSeparatorCountInputStream(InputStream input){
    this.input=input;
   
}
protected String lineRead() throws IOException{
  
   StringBuffer result=new StringBuffer();
   boolean isPreR=false;
   while(true){
       int read=input.read();
       if(read==-1){
           if(isPreR){
               result.append('\r');
           	   r++;
           }
           break;
       }
          
       else{
           if(read==(int)'\r')
               isPreR=true;
           else if(read==(int)'\n'){
               if(isPreR){
                   rn++;
                   result.append("\r\n");
               }else{
                   n++;
                   result.append('\n');
               }
               break;
           }else{
               if(isPreR){
                   r++;
                   result.append('\r');
                   isPreR=false;
                   result.append((char)read);
                   break;
               }else{
                   result.append((char)read);
               }
              
           }
       }
   }
   
   if(result.length()==0)
       return null;
   
   return result.toString();
}
/**
 * @return Returns the n.
 */
public int getN() {
    return n;
}
/**
 * @param n The n to set.
 */
public void setN(int n) {
    this.n = n;
}
/**
 * @return Returns the r.
 */
public int getR() {
    return r;
}
/**
 * @param r The r to set.
 */
public void setR(int r) {
    this.r = r;
}
/**
 * @return Returns the rn.
 */
public int getRn() {
    return rn;
}
/**
 * @param rn The rn to set.
 */
public void setRn(int rn) {
    this.rn = rn;
}
public int read() throws IOException {
int ret=-1;
if(datas!=null){
    ret=(int)datas.charAt(0);
    datas=datas.substring(1);
    if(datas.length()==0)
        datas=null;
}else{
    datas=lineRead();
    if(datas!=null)
        return read();
}

        // TODO Auto-generated method stub
        return ret;
    }

}
