/*
 * Created on 2005/03/04
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.util;

/**
 * 
 *
 */




    import java.util.MissingResourceException;
    import java.util.ResourceBundle;

    public class Messages {

        private static final String BUNDLE_NAME = "org.jpn.xucker.commons.util.messages"; //$NON-NLS-1$

        private static final ResourceBundle RESOURCE_BUNDLE =
            ResourceBundle.getBundle(BUNDLE_NAME);

        private Messages() {
        }

        public static String getString(String key) {
            try {
                return RESOURCE_BUNDLE.getString(key);
            } catch (MissingResourceException e) {
                return '!' + key + '!';
            }
        }
    }

